Unit tde60r_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, DE60R_p;

function tde60r: String;

implementation

function tde60r: String;
var
NX,NXM1,J,J1,K,I,IERR :Integer;
XN,XK,H,GN,YT :Real;
GN1,GK1 :Boolean;
Y :Array [0..282] of Real;
DY :Array [0..282] of Real;
Z :Array [0..282] of Real;
ALP :Array [0..281] of Extended;
BET :Array [0..281] of Extended;
CK :Array [0..281] of Real;
CG :Array [0..563] of Real;
CR :Array [0..563] of Real;
X :Array [0..282] of Real;
GK :Array [0..1] of Real;
label
_1,_100,_101,_20;
begin
Result := '';  {   }
NX := 283;
NXM1 := NX-1;
XN := 0.0;
XK := 1.57079632679;
H := 0.001;
X[0] := XN;
X[281] := XK-0.02;
X[282] := XK;
J := 0;
J1 := 0;
for K:=1 to 28 do
 begin
  for I:=1 to 10 do
   begin
    J := J+1;
    J1 := J1+2;
    X[J+0] := X[J-1]+(I)*H;
    CG[J1-1] := X[J+0];
    CG[J1+0] := CG[J1-1];
    CR[J1-1] := 4.0*Sin(X[J+0])*(1.0+X[J+0])-2.0*Cos(X[J+0]);
    CR[J1+0] := CR[J1-1];
    CK[J-1] := 2.0+(X[J-1]+X[J+0])/2.0;
_1:
   end;
 end;
CG[561] := X[281];
CG[562] := CG[561];
CR[561] := 4.0*Sin(X[281])*(1.0+X[281])-2.0*Cos(X[281]);
CR[562] := CR[561];
CR[563] := 4.0*(1.0+XK);
CG[563] := XK;
CR[0] := -2.0;
CG[0] := 0.0;
CK[280] := 2.0+(X[280]+X[281])/2.0;
CK[281] := 2.0+(X[281]+X[282])/2.0;
GN1 := True;
GN := 0.0;
GK[0] := 1000.0;
GK[1] := +2000.0;
GK1 := False;
DE60R(CK,CG,CR,NX,X,GN1,GN,GK1,GK,Y,ALP,BET,IERR);
Result := Result + Format('%s',[' IERR=']);
Result := Result + Format('%2d ',[IERR]) + #$0D#$0A;
for I:=1 to NX do
 begin
  YT := 2.0*Sin(X[I-1]);
  Z[I-1] := Y[I-1]-YT;
_100:
 end;
for I:=1 to NXM1 do
 begin
_101:
  DY[I-1] := Y[I+0]-Y[I-1];
 end;
DY[NX-1] := Y[NX-1]-Y[NX-2];
Result := Result + Format('%s',[' XN=']);
Result := Result + Format('%20.16f ',[XN]);
Result := Result + Format('%s',['      XK=']);
Result := Result + Format('%20.16f ',[XK]);
Result := Result + Format('%s',['      NX=']);
Result := Result + Format('%5d ',[NX]);
Result := Result + Format('%s',['      Y']);
Result := Result + Format('%s',['                DY']);
Result := Result + Format('%s',['               Z' + #$0D#$0A]);
for I:=1 to NXM1 do
 begin
  Result := Result + Format('%20.16f %20.16f %20.16f ',
 [Y[I-1],DY[I-1],Z[I-1]]) + #$0D#$0A;
_20:
 end;
Result := Result + Format('%20.16f %20.16f %20.16f ',
 [Y[NX-1],DY[NX-1],Z[NX-1]]) + #$0D#$0A;
UtRes('tde60r',Result);  {     tde60r.res }
exit;
end;

end.
